#include "metadefs.h"


void print (s)
BYTE *s;

{	WORD l;

	l = strlen (s);
	wb_diskaccess (g_handle, TRUE, s, l);

}

 

void start_comment ()

{

	if (language == SHORT)
		return;

	switch (language) {

		case C :
			print ("/* ");
			break;

		case PASCAL :
			print ("{ ");
			break;

	}

}



void end_comment ()

{

	if (language == SHORT)
		return;

	switch (language) {

		case C :
			print (" */");
			break;

		case PASCAL :
			print (" }");
			break;

	}

	print ("\x0D\x0A");
}



void print_comment (s, b)
BYTE *s;
BOOLEAN b;

{

	if (language == SHORT)
		print (s);

	start_comment ();
	print (s);
	end_comment ();

	if (b)
		print ("\x0D\x0A");

}


void print_bool (b)
BOOLEAN b;

{

	if (language == SHORT)
		return;

	if (b)
		print (", TRUE");

	else
		print (", FALSE");

}



void print_number (n)
WORD n;

{	BYTE s [10];

	__itoa ((LONG) n, s);
	print (s);

}


void print_n (n)
WORD n;

{

	if (language == SHORT)
		return;

	print (", ");
	print_number (n);

}



void print_assign_start (lhs)
BYTE *lhs;

{

	if (language == SHORT)
		return;

	print ("    ");
	print (lhs);
	print (" ");

	if (language == PASCAL)
		print (":");

	print ("= ");

}



void print_string (a,b)
WORD a,b;

{	WORD i;
	BYTE s [128];
	
	if (language == SHORT)
		return;

	print (", \"");

	for (i = a; i < b; i++)
		s [i - a] = mf_intin [i];

	s [++i - a] = 0;
	print (s);
	print ("\"");

}



void print_x_coord (x)
WORD x;

{	
	if (language == SHORT)
		return;

	if (structure == FUNCTION) {

		print ("x_udx_xform (");
		print_number (x);
		print (")");

	} else
		print_number (x);

}



void print_y_coord (y)
WORD y;

{	
	if (language == SHORT)
		return;

	if (structure == FUNCTION) {

		print ("x_udy_xform (");
		print_number (y);
		print (")");

	} else
		print_number (y);

}



void print_coord (x, y)
WORD x, y;

{

	if (language == SHORT)
		return;

	print (", ");
	print_x_coord (x);
	print (", ");
	print_y_coord (y);

}


void print_width (x)
WORD x;

{	
	if (language == SHORT)
		return;

	if (structure == FUNCTION) {

		print (", x_udx_scale (");
		print_number (x);
		print (")");

	} else
		print_number (x);

}



void print_height (y)
WORD y;

{	
	if (language == SHORT)
		return;

	if (structure == FUNCTION) {

		print (", x_udy_scale (");
		print_number (y);
		print (")");

	} else
		print_number (y);

}



void print_arg_x (x)
WORD x;

{
	if (language == SHORT)
		return;

	print (", ");
	print_x_coord (x);

}



void print_arg_y (y)
WORD y;

{
	if (language == SHORT)
		return;

	print (", ");
	print_y_coord (y);

}



void print_pxy (start, finish, pxy, are_coordinates, array_name)
WORD start, finish, pxy [];
BOOLEAN are_coordinates;
BYTE *array_name;

{	WORD i;
	BYTE lhs [128], n [32];

	if (language == SHORT)
		return;

	for (i = start; i < finish; i++) {

		strcpy (lhs, array_name);
		strcat (lhs, " [");
		__itoa ((LONG) i, n);
		strcat (lhs, n);
		strcat (lhs, "]");
		print_assign_start (lhs);

		if (! are_coordinates)
			print_n (pxy [i]);

		else
		if (i & 1)
			print_y_coord (pxy [i]);

		else
			print_x_coord (pxy [i]);

		print (";\x0D\x0A");

	}

}



void print_ptsin ()

{
	if (language != SHORT)
		print (", pxyarray");
}




void print_function_start (fnctn)
BYTE *fnctn;

{

	wb_default (tree, COUNT, fnctn);

	if (language == SHORT) {

		print (fnctn);
		print ("\x0D\x0A");

	} else {

      print ("\#ifdef DEBUG\x0D\x0A");
		print ("    form_alert (1, ADDR (\"[1][");
	   print (fnctn);
		print ("][  Ok  ]\"));\x0D\x0A");
      print ("\#endif\x0D\x0A");
		print ("    ");

		if (language == PASCAL)
			print ("ret := ");

		print (fnctn);
		print (" (vdi_handle");

	}

	quantity_functions++;

}


void print_function_finish ()

{

	if (language == SHORT)
		return;

	print (");\x0D\x0A\x0D\x0A");

}



void print_null_function (f)
BYTE *f;

{

	if (language == SHORT)
		print (f);

	print_function_start (f);
	print_function_finish ();

}



void print_one_function (f, n)
BYTE *f;
WORD n;

{
	print_function_start (f);
	print_n (n);
	print_function_finish ();
}



void print_constant (s, t)
BYTE *s, *t;

{

	switch (language) {

		case C :
			print ("#define ");
			print (s);
			print (" ");
			print (t);
			break;

		case PASCAL :

			if (first_constant) {

				first_constant = FALSE;
				print ("CONST\x0D\x0A\x0D\x0A");

			}

			print (s);
			print (" = ");
			print (t);
			print (";");
			break;

	}	

}



void print_header (s, n)
BYTE *s;
WORD n;

{	BYTE t [32];

	__itoa ((LONG) n, t);

	switch (header_info) {

		case COMMENT :
			start_comment ();
			print (s);
			print (" is ");
			print (t);
			end_comment ();
			break;

		case CONSTANT :
			print_constant (s, t);
			break;

	}

	print ("\x0D\x0A");

}



void print_function_header ()

{	BYTE reply [128];

	wb_reply (tree, FNAME, reply);

	switch (language) {

		case C :
			print ("#ifndef WORD\x0D\x0A");
			print ("#include <bench.h>\x0D\x0A");
			print ("#endif\x0D\x0A\x0D\x0A");
			print ("\x0D\x0A\x0D\x0Avoid ");
			print (reply);
			print (" (vdi_handle, area, is_metafile, out)\x0D\x0A");
			print ("WORD    vdi_handle;   /* device used to display drawing */\x0D\x0A");
			print ("GRECT  *area;	      /* area containing drawing */\x0D\x0A");
			print ("BOOLEAN is_metafile;  /* TRUE if device is a metafile */\x0D\x0A");
			print ("WORD    out [];       /* result of v_opnwk () or v_opnvwk () */");
			print ("\x0D\x0A\x0D\x0A{  WORD pxyarray [512];\x0D\x0A");
			print ("   WORD mf_intin [512];\x0D\x0A");
			print ("   WORD mf_ptsin [512];\x0D\x0A");
			print ("   WORD old_width, old_height;\x0D\x0A\x0D\x0A    ");
			print_comment ("Prepare transformations (see XLIB.C in ToolKit)", FALSE);
			print ("    old_width = area -> g_w;\x0D\x0A");
			print ("    old_height = area -> g_h;\x0D\x0A");
			print ("    x_saspect (");
			print_number (buffer.mf [6] - buffer.mf [4] + 1);
			print_n (buffer.mf [7] - buffer.mf [5] + 1);
			print (", &area -> g_w, &area -> g_h, out);\x0D\x0A\x0D\x0A");
			print ("    if (area -> g_w != old_width)\x0D\x0A");
			print ("      area -> g_x += (old_width - area -> g_w) / 2;\x0D\x0A\x0D\x0A");
			print ("    if (area -> g_h != old_height)\x0D\x0A");
			print ("      area -> g_y += (old_height - area -> g_h) / 2;\x0D\x0A\x0D\x0A");
			print ("    x_sxform (");
			print_number (buffer.mf [4]);
			print_n (buffer.mf [5]);
			print_n (buffer.mf [6] - buffer.mf [4] + 1);
			print_n (buffer.mf [7] - buffer.mf [5] + 1);
			print (", area -> g_x, area -> g_y, area -> g_w, area -> g_h);\x0D\x0A\x0D\x0A");
			break;

		case PASCAL :
			print ("\x0D\x0A\x0D\x0AProcedure ");
			print (reply);
			print (" (vdi_handle : integer; area : GRECT; is_metafile : boolean);\x0D\x0A");
			print ("{ vdi_handle is device used to display drawing,\x0D\x0A");
			print ("  area is the area containing drawing, is_metafile\x0D\x0A");
			print ("  is TRUE if the device is a metafile. }\x0D\x0A\x0D\x0A");
			print ("VAR\x0D\x0A    pxyarray : ARRAY [0..63] OF integer;\x0D\x0A\x0D\x0A");
			print ("    ret : integer;\x0D\x0A\x0D\x0A");
			print ("BEGIN\x0D\x0A\x0D\x0A");
			print_comment ("Prepare transformations (see XLIB.C in ToolKit)", FALSE);
			print ("    x_sxform (");
			print_number (buffer.mf [4]);
			print_n (buffer.mf [5]);
			print_n (buffer.mf [6]);
			print_n (buffer.mf [7]);
			print (", area^.g_x, area^.g_y, area^.g_w, area^.g_h);\x0D\x0\x0D\x0AA");
			break;

	}

}



BOOLEAN print_top_of_code ()

{	LONG alert;

	mfread_buffer (0);
	hdr_size = buffer.mf [1];

	if (buffer.mf [0] != 0xFFFF) {

		rsrc_gaddr (R_STRING, NOTMETA, &alert);
		form_alert (1, alert);
		return (FALSE);

	}

	if (header_info != IGNORE) {

		print_header ("HEADER_SIZE", buffer.mf [1]);
		print_header ("VERSION", buffer.mf [2]);
		print_header ("NDC_RC_FLAG", buffer.mf [3]);
		print_header ("MIN_X_EXTENT", buffer.mf [4]);
		print_header ("MIN_Y_EXTENT", buffer.mf [5]);
		print_header ("MAX_X_EXTENT", buffer.mf [6]);
		print_header ("MAX_Y_EXTENT", buffer.mf [7]);
		print_header ("PHYSICAL_X", buffer.mf [8]);
		print_header ("PHYSICAL_y", buffer.mf [9]);
		print_header ("LOWER_LEFT_X", buffer.mf [10]);
		print_header ("LOWER_LEFT_Y", buffer.mf [11]);
		print_header ("UPPER_RIGHT_X", buffer.mf [12]);
		print_header ("UPPER_RIGHT_Y", buffer.mf [13]);
		print_header ("BIT_IMAGE_FLAG", buffer.mf [14]);

	}

	if (structure == FUNCTION)
		print_function_header ();

	return (TRUE);

}




void print_end_of_program ()

{

	switch (language) {

		case C :
			print ("\x0D\x0A}\x0D\x0A\x0D\x0A");
			break;

		case PASCAL :
			print ("\x0D\x0AEND;\x0D\x0A\x0D\x0A");
			break;

	}

}
